<template>
  <section class="carditem--container">
    <header>
      <div v-if="cardData.newItem" class="new">NEW</div>
      <img
        @mouseover="updatePlayIcon(true)"
        @mouseleave="updatePlayIcon(false)"
        class="carditem--container--image"
        :src="require(`@/assets/img/${cardData.url}_md_op.jpeg`)"
        :srcset="require(`@/assets/img/${cardData.url}_md_op.jpeg`) + ' 2x, ' + require(`@/assets/img/${cardData.url}_sm_op.jpeg`) + ' 1x'"
        :alt="cardData.description"
      />
      <img v-if="showPlayIcon" class="carditem--container--play" src="../../assets/icons/play.svg" alt="Play!" />
      <div class="carditem--container--indicators">
        <strong class="badget quality">{{ cardData.quality }}</strong>
        <span class="badget">{{ cardData.time }}</span>
      </div>
    </header>
    <main>
      <p>{{ cardData.description }}</p>
    </main>
    <footer>
      <ul>
        <li>
          <div class="badget" v-for="({ name }, index) in categories" :key="`${cardData.id}-${index}`">
            {{ name }}
          </div>
        </li>
      </ul>
      <img
        src="../../assets/icons/circle.svg"
        class="showmore--icon"
        alt="Show more"
        @click="
          () => {
            this.toggleMoreSections(this.cardData.id);
          }
        "
      />
    </footer>
  </section>
</template>

<script>
export default {
  name: 'CardItem',
  props: {
    cardData: {
      type: Object,
    },
    categories: {
      type: Array,
      default: () => [],
    },
    toggleMoreSections: {
      type: Function,
      default: () => {},
    },
  },
  data() {
    return {
      showPlayIcon: false,
    };
  },
  methods: {
    updatePlayIcon(val) {
      this.showPlayIcon = val;
    },
  },
};
</script>

<style lang="sass" scoped>
@import '@/assets/sass/colors.sass'
@import '@/assets/sass/sizes.sass'

header
  height: 300px
  position: relative
  overflow: hidden
img
  height: -webkit-fill-available
  position: relative
  width: 150px
  height: -moz-available
  overflow: hidden

.carditem--container--image
  object-fit: cover
  min-height: 300px
  min-width: -webkit-fill-available
  min-width: -moz-available
.carditem--container--image:hover
  opacity: .2
  cursor: pointer
  z-index: 3
.carditem--container--play
  position: absolute
  top: 0
  width: 17%
  height: 100%
  left: 0
  right: 0
  margin: auto
ul
  display: flex
  flex-direction: row
  width: 85%
  li
    cursor: pointer
main
  text-align: left
  padding: 0 .4rem
footer
  padding: $sm-size .4rem
  display: flex
  align-items: flex-start
  justify-content: space-between
  img
    margin-top: .4rem
  li
    display: flex
    flex-wrap: wrap
    font-size: $xs-size
  .badget
    border: 1px solid $primary-ligth
    border-radius: 5px
    padding: .2rem $sm-size
    margin-right: .5rem
    margin-bottom: .4rem
    min-width: fit-content
img
  width: -webkit-fill-available
  width: -moz-available
.badget
  background: rgba(0,0,0,.5)
  border-radius: 8px
  padding: .4rem $md-size
  height: fit-content
.quality
  font-size: $xxlg-size
.showmore--icon
  height: 18px
  width: 18px
  cursor: pointer
.carditem--container--indicators
  position: relative
  align-items: flex-end
  bottom: 4.5rem
  padding: 0 $xs-size
  display: flex
  justify-content: space-between
img::before
  content: ''
  background: red
  height: 100%
  width: 100%
  transition: opacity .5s
  z-index: 9999
img:hover::before
  opacity: .5
  cursor: pointer
.new
  position: absolute
  z-index: 1
  left: -45px
  top: 25px
  width: 156px
  height: 25px
  overflow: hidden
  background-color: $warning
  transform: rotate(-45deg)
  -ms-transform: rotate(-45deg)
  -webkit-transform: rotate(-45deg)
  display: flex
  justify-content: center
  align-items: center
  color: #FFFFFF
</style>
